; Panning demootje

	MOV AX,3                ; 80x25-modus
	INT 10h

	MOV DX,3D4h             ; 160 kolommen
	MOV AX,5013h
	OUT DX,AX

	MOV AX,200Eh            ; Cursor buiten scherm
	OUT DX,AX

	PUSH DS                 ; BIOS-variabelen aanpassen
	MOV DS,BX
	MOV B [44Ah],160
	MOV B [484h],50
	MOV W [44Ch],8000

	MOV AL,[485h]           ; Eigen variabelen aanpassen
	POP DS
	MOV hoog,AL
	CMP AL,8                ; 640x200 monitor?
	IF E DEC B stapy
	MOV AX,1A00h            ; VGA?
	INT 10h
	CMP AL,1Ah
	JNE p0
	INC B breed
	INC B stapx
P0:     MOV AL,80
	MUL breed
	MOV maxx,AX
	MOV AL,25
	MUL hoog
	MOV maxy,AX

	MOV SI,offset dump      ; Text op scherm
	MOV AX,0B800h
	MOV ES,AX
	MOV AH,23
	XOR DI,DI
T0:     LODSB
	OR AL,AL
	JZ t1
	CMP AL,196
	JZ t1
	CMP AL,205
	JZ t1
	CMP AL,219
	JNZ t2
T1:     MOV CL,[SI]
	INC SI
	REP
T2:     STOSW
	INC AL
	JNZ t0

MAIN:   MOV AH,1                ; Lees toetsenbord
	INT 16h
	JZ m1
	MOV AH,0
	INT 16h
	CMP AX,11Bh             ; [Esc]?
	JNE m0
	MOV AX,3                ; Einde
	INT 10h
	RET

M0:     OR AL,AL                ; Pijltjes -> 1,2,3,4 -> R
	JNZ m5
	SUB AH,47h
	SHR AH,1
	IF Z INC AH
	MOV r,AH
M1:     MOV AH,r   
	DEC AH
	JNZ m2
	CMP W y,0               ; Omhoog
	JE m5
	MOV AX,stapy
	SUB y,AX
	JMP m6
M2:     DEC AH
	JNZ m3
	CMP W x,0               ; Links
	JE m5
	MOV AX,stapx
	SUB x,AX
	JMP m6
M3:     DEC AH
	JNZ m4
	MOV AX,x                ; Rechts
	CMP AX,maxx
	JE m5
	MOV AX,stapx
	ADD x,AX
	JMP m6
M4:     DEC AH
	JNE m5
	MOV AX,y                ; Omlaag
	CMP AX,maxy
	JE m5
	MOV AX,stapy
	ADD y,AX
	JMP m6
M5:     MOV B r,0

M6:     MOV AX,x                ; 'PAN'
	DIV breed
	CMP breed,9              ; Voor 9 pixels aanpassen !!!
	JNE m7
	DEC AH
	IF S MOV AH,8
M7:     MOV CL,AH               ; CL = Waarde 'Horizontal pixel pan'
	CBW
	MOV BX,AX
	MOV AX,y
	DIV hoog
	MOV CH,AH               ; CH = Waarde 'Preset row scan'
	MOV AH,160
	MUL AH
	ADD BX,AX               ; BX = Waarde 'start address'

	MOV DL,0DAh

M8:     IN AL,DX                ; Wacht op einde 'vertical retrace'
	TEST AL,8
	JNZ m8

	CLI                     ; Schrijf 'start address'
	SUB DL,6
	MOV AH,BH
	MOV AL,0Ch
	OUT DX,AX
	MOV AH,BL
	INC AL
	OUT DX,AX
	STI

	ADD DL,6                ; Wacht begin 'vertical retrace'
M9:     IN AL,DX
	TEST AL,8
	JZ m9

	CLI                     ; Schrijf 'Preset row scan'
	SUB DL,6
	MOV AH,CH
	MOV AL,8
	OUT DX,AX
	MOV DL,0C0h             ; Schrijf 'Horizontal pixel pan'
	MOV AL,33h
	OUT DX,AL
	MOV AL,CL
	OUT DX,AL
	STI
	
	JMP main

R       DB 0                    ; Variabelen
X       DW 0
Y       DW 0

MAXX    DW ?
MAXY    DW ?
STAPX   DB 2,0
STAPY   DB 2,0

HOOG    DB ?
BREED   DB 8

DUMP:   DB 0,4,'',0,'',0,'',3,'D 160 Kolommen H',0,4,'',0,'',0
	DB '',0,'',0,'',0,'5',2,'',1,'  ',1,'',1,'  ',1,''
	DB 0,3,'',2,' ',1,'',0,3,'',2,' ',2,' ',1,'',0,3,'',2,'  '
	DB 1,'',1,0,'6',0,'5 ',2,'  ',2,' ',2,0,3,'',2,' ',3,' ',2
	DB ' ',3,' ',2,'  ',2,'  ',3,' ',2,' ',2,0,';',0,'5 ',2
	DB '  ',2,'',2,' ',7,' ',7,'  ',2,'  ',7,' ',2,' ',0
	DB '6',0,'5 ',2,0,5,'',2,0,3,'',2,' ',2,' ',3,' ',2,' ',3
	DB '  ',2,'  ',2,' ',3,' ',2,0,3,'',2,0,'6',0,'5',2,0,5,'',2
	DB 0,3,'',2,' ',2,0,3,'',1,' ',2,0,3,'',1,' ',2,' ',2,0,3
	DB '',1,'  ',1,'',2,0,'6',0,'',0,'',0,'',0,30,'',2
	DB '',1,' ',2,'',2,' ',2,' ',2,'  ',3,'  ',1,'',0,3
	DB '',2,' ',1,'',1,' ',1,'',2,'',1,' ',2,'',1
	DB '  ',1,'',1,'  ',1,'',2,'',1,' ',2,'  ',3,'  ',1
	DB '',0,3,'',2,0,31,'',0,30,' ',2,'  ',2,'  ',2,0,5,'',7,' ',2
	DB 0,3,'',2,' ',3,' ',2,' ',1,'',0,7,'',2,0,4,'',2,'  ',2
	DB ' ',2,0,3,'',2,0,3,'',2,0,4,'',2,'  ',2,0,3,'',2,' ',3,' '
	DB 2,0,31,'',0,30,' ',2,'  ',2,'  ',2,'',0,3,'',2,' ',1,' ',2
	DB ' ',2,0,3,'',2,' ',7,0,3,'',1,'',0,4,'',2,0,4,'',4,'  '
	DB 2,'',2,0,3,'',2,0,4,'',2,'  ',2,0,3,'',2,' ',7,0,31,'',0
	DB 30,' ',2,'  ',2,'  ',2,0,5,'',2,0,3,'',2,' ',2,0,3,'',2,' '
	DB 2,' ',3,0,6,'',2,0,3,'',2,0,4,'',2,' ',1,' ',2,0,3,'',2,0
	DB 3,'',2,0,4,'',2,'  ',2,0,3,'',2,' ',2,' ',3,0,31,'',0,30
	DB '',2,'',1,' ',2,'',2,' ',2,0,3,'',2,'  ',3,'  ',2
	DB 0,3,'',1,' ',1,'',1,'  ',2,'  ',2,'  ',2,' ',2,0,3
	DB '',2,'  ',2,'  ',2,'  ',3,'  ',2,0,3,'',1,0,31,'',0
	DB '',0,'',0,'',0,'50 Regels',0,'',0,'',0,27,'b',0,' ',0
	DB 27,'',0,'b',0,' ',0,27,'',0,5,1,0,2,2,0,2,3,0,2,4,0,2,5,0,2,6,0
	DB 2,7,0,2,8,0,2,9,0,2,10,0,2,11,0,2,12,0,2,13,0,2,14,0,2,15,0,2,16,0
	DB 2,17,0,2,18,0,2,19,0,2,20,0,2,21,0,2,22,0,2,23,0,2,24,0,2,25,0,2,26
	DB 0,2,27,0,2,28,0,2,29,0,2,30,0,2,31,'  ',0,' ',0,27,'',0,'b',0
	DB ' ',0,27,'',0,5,'!  "  #  $  %  &  ''  (  )  *  +  ,  -  .  /  0'
	DB '  1  2  3  4  5  6  7  8  9  :  ;  <  =  >  ?  ',0,' ',0,27,''
	DB 0,'b',0,' ',0,27,'  @  A  B  C  D  E  F  G  H  I  J  K  L  M  N'
	DB '  O  P  Q  R  S  T  U  V  W  X  Y  Z  [  \  ]  ^  _  ',0,' ',0
	DB 27,'',0,'b',0,' ',0,27,'  `  a  b  c  d  e  f  g  h  i  j  k  '
	DB 'l  m  n  o  p  q  r  s  t  u  v  w  x  y  z  {  |  }  ~  ',127,' '
	DB ' ',0,' ',0,27,'',0,'b',0,' ',0,27,'                '
	DB '                                            '
	DB '      ',0,' ',0,27,'',0,'b',0,' ',0,27,'           '
	DB '                                           '
	DB '            ',0,' ',0,27,'',0,'b',0,' ',0,27,'      '
	DB '    ',1,'                  ',1,'              '
	DB '              ',1,'          ',0,' ',0,27,'',0,'b'
	DB 0,' ',0,27,'                                   '
	DB '                           ',0,5,'',0,' ',0,27,''
	DB 0,'b',0,' ',0,27,'b',0,' ',0,'',0,'',0,'',0
	DB 'End of buffer',0,5,'',0,'',255
